
(function ($, Drupal) {
  Drupal.behaviors.custom_jsoneditor = {
    attach: function (context) {
      $('.jsoneditor--wrapper').each(function () {
        if(context != document && context.nodeName != 'FORM') {
          return;
        }

        var options = {
          mode: 'tree',
          modes: ['code', 'tree', 'view', 'form', 'text'],
          ace: ace,
          container: this,
          onChangeText: function (jsonString) {
            var input = getInputFromContainer(this.container);
            if (input) {
              input.val(jsonString);
            }

            // Call api
            $.post('/admin/demo/api', {json_data: jsonString}, function (response) {
              // Document viwer.
              $('#document-view-content').html(response.view);

              // Json Response
              var editorDiv = $('div.jsoneditor--wrapper[data-input="ws_response"]:first');
              if (editorDiv.length > 0) {
                editorDiv[0].editor.set(response.result);
              }
            });
          }
        };

        if (!this.editor) {
          this.editor = new JSONEditor(this, options);
        }
        var input = getInputFromContainer(this);

        if (input) {
          var inputValue = input.val();

          if (inputValue) {
            var json = JSON.parse(inputValue);
            this.editor.set(json);
          } else {
            this.editor.set([]);
          }
        }
      });
    },
  };

  function getInputFromContainer(container) {
    var inputName = $(container).data('input');

    if (inputName) {
      var input = $('input[name="' + inputName + '"]');

      if (input.length > 0) {
        return input;
      }
    }

    return null;
  }

  $.fn.updateJsonResponse = function (inputName, response) {
    // Document viwer.
    $('#document-view-content').html(response.view);

    // Json Response
    var editorDiv = $('div.jsoneditor--wrapper[data-input="ws_response"]:first');
    if (editorDiv.length > 0) {
      editorDiv[0].editor.set(response.result);
    }
  }

})(jQuery, Drupal);
